#include <bits/stdc++.h>
using namespace std;
#define ll long long
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,k;
    cin>>n>>k;
    int a[n][31]={};
    bool mne[n];
    for(int i=0;i<n;i++)
    {
        int x;
        mne[i]=true;
        cin>>x;
        int c=0;
        while(x!=0)
        {
            a[i][c]=x%2;
            x/=2;
        }
    }
    vector<int> v[31];
    int bol[30]={};
    int brr=1;
    for(int j=0;j<n;j++)
    {
        if(a[j][30]==1)
        {
            v[30].push_back(j);
        }
    }
    if(v[30].size()>=k-1)
    {
        bol[30]=true;
    }
    for(int i=29;i>=0;i--)
    {
        int curv[31]=0;
        bool boll=false;
        int prev=0;
        vector<int> nv;
        int wit[31]=0;
        for(int j=0;j<n;j++)
        {
            
        }

    }
    return 0;
}